diff a/test/lib/org/openjdk/asmtools/util/ProductInfo.java b/test/lib/org/openjdk/asmtools/util/ProductInfo.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/util/ProductInfo.java
@@ -0,0 +1,83 @@
+/*
+ * Copyright (c) 2009, 2014, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.asmtools.util;
+
+import java.util.ResourceBundle;
+
+/**
+ * Class providing an access to the product info.
+ * <i>productinfo.properties</i> will be generated during the build
+ */
+public class ProductInfo {
+
+    static {
+        init();
+    }
+
+    ;
+
+    /**
+     * Returns the value of the specified property
+     */
+    public static String getProperty(String propName) {
+        try {
+            return bundle.getString(propName);
+        } catch (java.util.MissingResourceException e) {
+            return null;
+        }
+    }
+
+    /**
+     * Version of the product in the short format, like 5.0
+     */
+    public static final String VERSION = version();
+
+    /**
+     * Full version of the product, including build number and date of creation
+     */
+    public static final String FULL_VERSION = fullVersion();
+
+    private static final String BUNDLE_NAME = "org.openjdk.asmtools.util.productinfo";
+
+    private static ResourceBundle bundle;
+
+    /**
+     * Initializes the bundle
+     */
+    private static void init() {
+        bundle = ResourceBundle.getBundle(BUNDLE_NAME);
+    }
+
+    private static String version() {
+        return getProperty("PRODUCT_VERSION");
+    }
+
+    private static String fullVersion() {
+        return getProperty("PRODUCT_NAME_LONG") + ", version " + version()
+                + " " + getProperty("PRODUCT_MILESTONE")
+                + " " + getProperty("PRODUCT_BUILDNUMBER")
+                + " (" + getProperty("PRODUCT_DATE") + ")";
+
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/AckermannBase.java b/test/micro/org/openjdk/bench/valhalla/ackermann/AckermannBase.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/AckermannBase.java
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2016, 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@Fork(3)
+@Warmup(iterations = 5, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public abstract class AckermannBase {
+
+    // ackermann(1,1748)+ ackermann(2,1897)+ ackermann(3,8); == 9999999 calls
+    // max depth - 3798
+    public static final int X1 = 1;
+    public static final int Y1 = 1748;
+    public static final int X2 = 2;
+    public static final int Y2 = 1897;
+    public static final int X3 = 3;
+    public static final int Y3 = 8;
+
+    public static final int OPI = 9999999;
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64byte.java b/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64byte.java
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.R64byte;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+
+public class Identity64byte extends AckermannBase {
+
+    private static R64byte ack_ref(R64byte x, R64byte y) {
+        return x.longValue() == 0 ?
+                new R64byte(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_ref(new R64byte(x.longValue()-1) , new R64byte(1)) :
+                        ack_ref(new R64byte(x.longValue()-1), ack_ref(x, new R64byte(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Ref() {
+        return ack_ref(new R64byte(X1), new R64byte(Y1)).longValue()
+                + ack_ref(new R64byte(X2), new R64byte(Y2)).longValue()
+                + ack_ref(new R64byte(X3), new R64byte(Y3)).longValue();
+    }
+
+    private static Int64 ack_inter(Int64 x, Int64 y) {
+        return x.longValue() == 0 ?
+                new R64byte(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_inter(new R64byte(x.longValue()-1) , new R64byte(1)) :
+                        ack_inter(new R64byte(x.longValue()-1), ack_inter(x, new R64byte(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Int() {
+        return ack_inter(new R64byte(X1), new R64byte(Y1)).longValue()
+                + ack_inter(new R64byte(X2), new R64byte(Y2)).longValue()
+                + ack_inter(new R64byte(X3), new R64byte(Y3)).longValue();
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64int.java b/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64int.java
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.R64int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+
+public class Identity64int extends AckermannBase {
+
+    private static R64int ack_ref(R64int x, R64int y) {
+        return x.longValue() == 0 ?
+                new R64int(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_ref(new R64int(x.longValue()-1) , new R64int(1)) :
+                        ack_ref(new R64int(x.longValue()-1), ack_ref(x, new R64int(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Ref() {
+        return ack_ref(new R64int(X1), new R64int(Y1)).longValue()
+                + ack_ref(new R64int(X2), new R64int(Y2)).longValue()
+                + ack_ref(new R64int(X3), new R64int(Y3)).longValue();
+    }
+
+    private static Int64 ack_inter(Int64 x, Int64 y) {
+        return x.longValue() == 0 ?
+                new R64int(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_inter(new R64int(x.longValue()-1) , new R64int(1)) :
+                        ack_inter(new R64int(x.longValue()-1), ack_inter(x, new R64int(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Int() {
+        return ack_inter(new R64int(X1), new R64int(Y1)).longValue()
+                + ack_inter(new R64int(X2), new R64int(Y2)).longValue()
+                + ack_inter(new R64int(X3), new R64int(Y3)).longValue();
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64long.java b/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/Identity64long.java
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.R64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+
+public class Identity64long extends AckermannBase {
+
+    private static R64long ack_ref(R64long x, R64long y) {
+        return x.longValue() == 0 ?
+                new R64long(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_ref(new R64long(x.longValue()-1) , new R64long(1)) :
+                        ack_ref(new R64long(x.longValue()-1), ack_ref(x, new R64long(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Ref() {
+        return ack_ref(new R64long(X1), new R64long(Y1)).longValue()
+                + ack_ref(new R64long(X2), new R64long(Y2)).longValue()
+                + ack_ref(new R64long(X3), new R64long(Y3)).longValue();
+    }
+
+    private static Int64 ack_inter(Int64 x, Int64 y) {
+        return x.longValue() == 0 ?
+                new R64long(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_inter(new R64long(x.longValue()-1) , new R64long(1)) :
+                        ack_inter(new R64long(x.longValue()-1), ack_inter(x, new R64long(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Int() {
+        return ack_inter(new R64long(X1), new R64long(Y1)).longValue()
+                + ack_inter(new R64long(X2), new R64long(Y2)).longValue()
+                + ack_inter(new R64long(X3), new R64long(Y3)).longValue();
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/IdentityLong.java b/test/micro/org/openjdk/bench/valhalla/ackermann/IdentityLong.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/IdentityLong.java
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+
+public class IdentityLong extends AckermannBase {
+
+    private static Long ack_Long(Long x, Long y) {
+        return x == 0 ?
+                y + 1 :
+                (y == 0 ?
+                        ack_Long(x - 1, 1L) :
+                        ack_Long(x - 1, ack_Long(x, y - 1)));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ref_Long() {
+        return ack_Long(Long.valueOf(X1), Long.valueOf(Y1))
+                + ack_Long(Long.valueOf(X2), Long.valueOf(Y2))
+                + ack_Long(Long.valueOf(X3), Long.valueOf(Y3));
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64byte.java b/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64byte.java
@@ -0,0 +1,81 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64byte;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+
+public class Inline64byte extends AckermannBase {
+
+    private static Q64byte ack_value(Q64byte x, Q64byte y) {
+        return x.longValue() == 0 ?
+                new Q64byte(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_value(new Q64byte(x.longValue()-1) , new Q64byte(1)) :
+                        ack_value(new Q64byte(x.longValue()-1), ack_value(x, new Q64byte(y.longValue()-1))));
+    }
+
+//    @Benchmark
+//    @OperationsPerInvocation(OPI)
+// TODO fix StackOverflowException
+    public long ack_Val() {
+        return ack_value(new Q64byte(X1), new Q64byte(Y1)).longValue()
+                + ack_value(new Q64byte(X2), new Q64byte(Y2)).longValue()
+                + ack_value(new Q64byte(X3), new Q64byte(Y3)).longValue();
+    }
+
+    private static Q64byte ack_ref(Q64byte x, Q64byte y) {
+        return x.longValue() == 0 ?
+                new Q64byte(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_ref(new Q64byte(x.longValue()-1) , new Q64byte(1)) :
+                        ack_ref(new Q64byte(x.longValue()-1), ack_ref(x, new Q64byte(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Ref() {
+        return ack_ref(new Q64byte(X1), new Q64byte(Y1)).longValue()
+                + ack_ref(new Q64byte(X2), new Q64byte(Y2)).longValue()
+                + ack_ref(new Q64byte(X3), new Q64byte(Y3)).longValue();
+    }
+
+    private static Int64 ack_inter(Int64 x, Int64 y) {
+        return x.longValue() == 0 ?
+                new Q64byte(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_inter(new Q64byte(x.longValue()-1) , new Q64byte(1)) :
+                        ack_inter(new Q64byte(x.longValue()-1), ack_inter(x, new Q64byte(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Int() {
+        return ack_inter(new Q64byte(X1), new Q64byte(Y1)).longValue()
+                + ack_inter(new Q64byte(X2), new Q64byte(Y2)).longValue()
+                + ack_inter(new Q64byte(X3), new Q64byte(Y3)).longValue();
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64int.java b/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64int.java
@@ -0,0 +1,80 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+
+public class Inline64int extends AckermannBase {
+
+    private static Q64int ack_value(Q64int x, Q64int y) {
+        return x.longValue() == 0 ?
+                new Q64int(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_value(new Q64int(x.longValue()-1) , new Q64int(1)) :
+                        ack_value(new Q64int(x.longValue()-1), ack_value(x, new Q64int(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Val() {
+        return ack_value(new Q64int(X1), new Q64int(Y1)).longValue()
+                + ack_value(new Q64int(X2), new Q64int(Y2)).longValue()
+                + ack_value(new Q64int(X3), new Q64int(Y3)).longValue();
+    }
+
+    private static Q64int ack_ref(Q64int x, Q64int y) {
+        return x.longValue() == 0 ?
+                new Q64int(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_ref(new Q64int(x.longValue()-1) , new Q64int(1)) :
+                        ack_ref(new Q64int(x.longValue()-1), ack_ref(x, new Q64int(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Ref() {
+        return ack_ref(new Q64int(X1), new Q64int(Y1)).longValue()
+                + ack_ref(new Q64int(X2), new Q64int(Y2)).longValue()
+                + ack_ref(new Q64int(X3), new Q64int(Y3)).longValue();
+    }
+
+    private static Int64 ack_inter(Int64 x, Int64 y) {
+        return x.longValue() == 0 ?
+                new Q64int(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_inter(new Q64int(x.longValue()-1) , new Q64int(1)) :
+                        ack_inter(new Q64int(x.longValue()-1), ack_inter(x, new Q64int(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Int() {
+        return ack_inter(new Q64int(X1), new Q64int(Y1)).longValue()
+                + ack_inter(new Q64int(X2), new Q64int(Y2)).longValue()
+                + ack_inter(new Q64int(X3), new Q64int(Y3)).longValue();
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64long.java b/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/Inline64long.java
@@ -0,0 +1,80 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+
+public class Inline64long extends AckermannBase {
+
+    private static Q64long ack_value(Q64long x, Q64long y) {
+        return x.longValue() == 0 ?
+                new Q64long(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_value(new Q64long(x.longValue()-1) , new Q64long(1)) :
+                        ack_value(new Q64long(x.longValue()-1), ack_value(x, new Q64long(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Val() {
+        return ack_value(new Q64long(X1), new Q64long(Y1)).longValue()
+                + ack_value(new Q64long(X2), new Q64long(Y2)).longValue()
+                + ack_value(new Q64long(X3), new Q64long(Y3)).longValue();
+    }
+
+    private static Q64long ack_ref(Q64long x, Q64long y) {
+        return x.longValue() == 0 ?
+                new Q64long(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_ref(new Q64long(x.longValue()-1) , new Q64long(1)) :
+                        ack_ref(new Q64long(x.longValue()-1), ack_ref(x, new Q64long(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Ref() {
+        return ack_ref(new Q64long(X1), new Q64long(Y1)).longValue()
+                + ack_ref(new Q64long(X2), new Q64long(Y2)).longValue()
+                + ack_ref(new Q64long(X3), new Q64long(Y3)).longValue();
+    }
+
+    private static Int64 ack_inter(Int64 x, Int64 y) {
+        return x.longValue() == 0 ?
+                new Q64long(y.longValue() + 1) :
+                (y.longValue() == 0 ?
+                        ack_inter(new Q64long(x.longValue()-1) , new Q64long(1)) :
+                        ack_inter(new Q64long(x.longValue()-1), ack_inter(x, new Q64long(y.longValue()-1))));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long ack_Int() {
+        return ack_inter(new Q64long(X1), new Q64long(Y1)).longValue()
+                + ack_inter(new Q64long(X2), new Q64long(Y2)).longValue()
+                + ack_inter(new Q64long(X3), new Q64long(Y3)).longValue();
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/ackermann/Primitive64.java b/test/micro/org/openjdk/bench/valhalla/ackermann/Primitive64.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/ackermann/Primitive64.java
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.ackermann;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+
+public class Primitive64 extends AckermannBase {
+
+    private static long ack_primitive(long x, long y) {
+        return x == 0 ?
+                y + 1 :
+                (y == 0 ?
+                        ack_primitive(x - 1, 1) :
+                        ack_primitive(x - 1, ack_primitive(x, y - 1)));
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(OPI)
+    public long primitive() {
+        return ack_primitive(X1, Y1)
+                + ack_primitive(X2, Y2)
+                + ack_primitive(X3, Y3);
+    }
+
+}
